//+------------------------------------------------------------------+
//|                                                           LN.mq4 |
//+------------------------------------------------------------------+
extern int    period=50;
extern int    ma_shift=0;
extern int    Magic=666;
extern double lot=0.1;
extern int    SL=150;
extern int    MinMovePrice = 80;                 // AB  .
extern int    OtkatPercent = 40;
double        gd_MinMovePrice;
int           gi_Slippage = 10;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
    gd_MinMovePrice = MinMovePrice * Point;
//----
    return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----
    int kolpos = 0;
//----
    for (int pos = OrdersTotal() - 1; pos >= 0; pos--)
    {
        if (!OrderSelect (pos, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != Symbol()) continue;
        if (OrderMagicNumber() != Magic) continue;
        if (OrderType() > 1) continue;
        if (fClose_AtOtkat (gi_Slippage, gd_MinMovePrice, OtkatPercent)) continue;
        kolpos++;
    }
    if (kolpos == 0)
    {
        double ma = iMA (NULL, 0, period, ma_shift, MODE_SMMA, PRICE_MEDIAN, 0);
        if(Open[1]>ma) if (Close[1]<ma)  
        OrderSend (Symbol(),OP_SELL,lot,Bid,gi_Slippage,Bid+SL*Point,0,NULL,Magic,0,Red);
        if(Open[1]<ma) if (Close[1]>ma)  
        OrderSend (Symbol(),OP_BUY,lot,Ask,gi_Slippage,Ask-SL*Point,0,NULL,Magic,0,Green);
    }
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fClose_AtOtkat (int fi_Slippage,              //   .
                     double fd_MinProfit,          //     ()
                     int fi_OtkatPercent = 50)     //    %
{
    int    li_Extrem, li_cmd = 1,
           li_Shift = iBarShift (Symbol(), Period(), OrderOpenTime());
    double ld_Price, ld_MovePrice, ld_Extrem;
//----
    RefreshRates();
    if (OrderType() == OP_SELL)
    {
        li_cmd = -1;
        ld_Price = Ask;
        li_Extrem = iLowest (Symbol(), Period(), MODE_LOW, li_Shift + 1);
        if (li_Shift <= li_Extrem) Print (OrderTicket(), ": shift[", li_Shift, "] = ", li_Extrem);
        ld_Extrem = iLow (Symbol(), Period(), li_Extrem);
    }
    else
    {
        ld_Price = Bid;
        li_Extrem = iHighest (Symbol(), Period(), MODE_HIGH, li_Shift + 1);
        if (li_Shift <= li_Extrem) Print (OrderTicket(), ": shift[", li_Shift, "] = ", li_Extrem);
        ld_Extrem = iHigh (Symbol(), Period(), li_Extrem);
    }
    //----      
    ld_MovePrice = li_cmd * (ld_Extrem - OrderOpenPrice());
    //----   "" 
    if (ld_MovePrice <= fd_MinProfit) return (false);
    //----    
    if (li_cmd * (ld_Extrem - ld_Price) > ld_MovePrice / 100. * fi_OtkatPercent)
    {
        if (OrderClose (OrderTicket(), OrderLots(), ld_Price, fi_Slippage))
        {
            Print ("fClose_AtOtkat(): #", OrderTicket(), "| Profit = ", OrderProfit(), " | MovePrice = ", ld_MovePrice / Point);
            return (true);
        }
    }
//----
    return (false);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

